Index: /branches/HeuristicLab.Mono/HeuristicLab 3.3.sln
===================================================================
--- /branches/HeuristicLab.Mono/HeuristicLab 3.3.sln	(revision 8446)
+++ /branches/HeuristicLab.Mono/HeuristicLab 3.3.sln	(revision 8447)
@@ -40,5 +40,4 @@
 		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD} = {489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}
 		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943} = {72104A0B-90E7-42F3-9ABE-9BBBADD4B943}
-		{3081630C-9521-47D7-8075-1777C12F212C} = {3081630C-9521-47D7-8075-1777C12F212C}
 		{8C265E11-4F8D-4CED-9E6B-F400A0075C18} = {8C265E11-4F8D-4CED-9E6B-F400A0075C18}
 		{25087811-F74C-4128-BC86-8324271DA13E} = {25087811-F74C-4128-BC86-8324271DA13E}
@@ -81,5 +80,4 @@
 		{7EA0985E-A1D6-4FA7-B30A-2633FDFB01F0} = {7EA0985E-A1D6-4FA7-B30A-2633FDFB01F0}
 		{E10F395F-C8A6-48AD-B470-9AA7A1F43809} = {E10F395F-C8A6-48AD-B470-9AA7A1F43809}
-		{B7A64A60-B538-479F-9C47-A3180C458F6C} = {B7A64A60-B538-479F-9C47-A3180C458F6C}
 		{4AE3FC69-C575-42D2-BC46-0FAD5850EFC5} = {4AE3FC69-C575-42D2-BC46-0FAD5850EFC5}
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7} = {56F9106A-079F-4C61-92F6-86A84C2D84B7}
@@ -114,5 +112,4 @@
 		{DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA} = {DBECB8B0-B166-4133-BAF1-ED67C3FD7FCA}
 		{887425B4-4348-49ED-A457-B7D2C26DDBF9} = {887425B4-4348-49ED-A457-B7D2C26DDBF9}
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55} = {25735DB4-8E54-4A2C-83E3-A60C76565E55}
 		{F4539FB6-4708-40C9-BE64-0A1390AEA197} = {F4539FB6-4708-40C9-BE64-0A1390AEA197}
 		{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C} = {A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}
@@ -218,8 +215,4 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.OneMax.Views-3.3", "HeuristicLab.Problems.OneMax.Views\3.3\HeuristicLab.Problems.OneMax.Views-3.3.csproj", "{4FE983A1-AAF8-4977-B9E2-52B3224510CB}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation-3.3", "HeuristicLab.Problems.ExternalEvaluation\3.3\HeuristicLab.Problems.ExternalEvaluation-3.3.csproj", "{25735DB4-8E54-4A2C-83E3-A60C76565E55}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.Views-3.3", "HeuristicLab.Problems.ExternalEvaluation.Views\3.3\HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj", "{3081630C-9521-47D7-8075-1777C12F212C}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.VehicleRouting-3.3", "HeuristicLab.Problems.VehicleRouting\3.3\HeuristicLab.Problems.VehicleRouting-3.3.csproj", "{6410BDA6-3641-42B2-BABA-AA626E2F6F71}"
 EndProject
@@ -267,6 +260,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Views-3.4", "HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj", "{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ExternalEvaluation.GP-3.4", "HeuristicLab.Problems.ExternalEvaluation.GP\3.4\HeuristicLab.Problems.ExternalEvaluation.GP-3.4.csproj", "{B7A64A60-B538-479F-9C47-A3180C458F6C}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.QuadraticAssignment-3.3", "HeuristicLab.Problems.QuadraticAssignment\3.3\HeuristicLab.Problems.QuadraticAssignment-3.3.csproj", "{79271BC8-4446-40E2-BB89-9BE4E17174FE}"
@@ -940,28 +931,4 @@
 		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.ActiveCfg = Release|x86
 		{4FE983A1-AAF8-4977-B9E2-52B3224510CB}.Release|x86.Build.0 = Release|x86
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|x64.ActiveCfg = Debug|x64
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|x64.Build.0 = Debug|x64
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|x86.ActiveCfg = Debug|x86
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Debug|x86.Build.0 = Debug|x86
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|Any CPU.Build.0 = Release|Any CPU
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|x64.ActiveCfg = Release|x64
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|x64.Build.0 = Release|x64
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|x86.ActiveCfg = Release|x86
-		{25735DB4-8E54-4A2C-83E3-A60C76565E55}.Release|x86.Build.0 = Release|x86
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|x64.ActiveCfg = Debug|x64
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|x64.Build.0 = Debug|x64
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|x86.ActiveCfg = Debug|x86
-		{3081630C-9521-47D7-8075-1777C12F212C}.Debug|x86.Build.0 = Debug|x86
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x64.ActiveCfg = Release|x64
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x64.Build.0 = Release|x64
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x86.ActiveCfg = Release|x86
-		{3081630C-9521-47D7-8075-1777C12F212C}.Release|x86.Build.0 = Release|x86
 		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{6410BDA6-3641-42B2-BABA-AA626E2F6F71}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1240,16 +1207,4 @@
 		{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}.Release|x86.ActiveCfg = Release|x86
 		{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}.Release|x86.Build.0 = Release|x86
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|x64.ActiveCfg = Debug|x64
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|x64.Build.0 = Debug|x64
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|x86.ActiveCfg = Debug|x86
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Debug|x86.Build.0 = Debug|x86
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|Any CPU.Build.0 = Release|Any CPU
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|x64.ActiveCfg = Release|x64
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|x64.Build.0 = Release|x64
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|x86.ActiveCfg = Release|x86
-		{B7A64A60-B538-479F-9C47-A3180C458F6C}.Release|x86.Build.0 = Release|x86
 		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{79271BC8-4446-40E2-BB89-9BE4E17174FE}.Debug|Any CPU.Build.0 = Debug|Any CPU
Index: /branches/HeuristicLab.Mono/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Mono/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 8446)
+++ /branches/HeuristicLab.Mono/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 8447)
@@ -465,16 +465,4 @@
       <Project>{DF87C13E-A889-46FF-8153-66DCAA8C5674}</Project>
       <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.ExternalEvaluation.GP\3.4\HeuristicLab.Problems.ExternalEvaluation.GP-3.4.csproj">
-      <Project>{B7A64A60-B538-479F-9C47-A3180C458F6C}</Project>
-      <Name>HeuristicLab.Problems.ExternalEvaluation.GP-3.4</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.ExternalEvaluation.Views\3.3\HeuristicLab.Problems.ExternalEvaluation.Views-3.3.csproj">
-      <Project>{3081630C-9521-47D7-8075-1777C12F212C}</Project>
-      <Name>HeuristicLab.Problems.ExternalEvaluation.Views-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.ExternalEvaluation\3.3\HeuristicLab.Problems.ExternalEvaluation-3.3.csproj">
-      <Project>{25735DB4-8E54-4A2C-83E3-A60C76565E55}</Project>
-      <Name>HeuristicLab.Problems.ExternalEvaluation-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.Instances.CordeauGQAP\3.3\HeuristicLab.Problems.Instances.CordeauGQAP-3.3.csproj">